let trouver_indice x l =
  let rec aux i l = match l with
      [] -> failwith "pas trouvé"
    | y::q when x=y -> i
    | _::q -> aux (i+1) q in
  aux 0 l;;

trouver_indice 1 [10;20;30;8;1;7;9];;
trouver_indice 1 [10;20;30;8;10;7;9];;

try
  List.hd [1;2]
with Failure _ -> 0;;

try
  List.hd []
with Failure _ -> 0;;


let doublon l =
  let rec aux i l = match l with
    | [] -> failwith "pas de doublon"
    | x::q ->
       try
         i, i + 1 + trouver_indice x q
       with Failure _ -> aux (i+1) q
  in aux 0 l;;


doublon [10;1;2;8;3;1;6;4;1];;

doublon [1;2;8;3;0;6;4];;


let rec fusion l1 l2 = match l1, l2 with
  | [], l | l, [] -> l
  | x1::t1, x2::t2 ->  if x1<=x2
    then x1 :: fusion t1 l2
    else x2 :: fusion l1 t2 ;;


fusion [10;15;20] [8;12;14;15;22];;

fusion [8] [2];;


(*en récursion terminale*)
let separer l=
  let rec aux acc1 acc2 l = match l with
    | [] -> acc1, acc2
    | [x] -> x::acc1, acc2
    | x::y::q -> aux (x::acc1) (y::acc2) q in
  aux [] [] l;;
    
separer [0;1;2;3;4;5];;

separer [0;1;2;3;4;5;6;7;8];;

separer [0;1;2;3;4];;


let rec tri l =
  match l with
  | [] | [_] -> l
  | _ -> let l1,l2 = separer l in
    let l'1= tri l1 and l'2 = tri l2 in
    fusion l'1 l'2;;

tri [6;3;8;2;1;9;4;3];;

tri [[4; 4]; [5; 6]; [5; 9]; [1; 4]; [11; 6]; [7; 2]; [4; 1]; [7; -1]; [8; 5];
 [1; 8]; [13; 1]; [0; 0]];;
